
PlayerClass = {}

function PlayerClass.new(p, x, y, dir, u, d, l, r)
	local p = p or {}
	setmetatable(p, {__index=PlayerClass})
	p.x = x
	p.y = y
	p.dir = dir
	p.up = u
	p.down = d
	p.left = l
	p.right = r
	
	p.speed = 100
	p.tracemode = false
	return p
end

function PlayerClass:update(dt)
	-- update
	local old_x, old_y
	old_x,old_y = p.x,p.y
	if love.keyboard.isDown(p.up) then	p.y = p.y - p.speed*dt
	elseif love.keyboard.isDown(p.down) then p.y = p.y + p.speed*dt
	elseif love.keyboard.isDown(p.left) then p.x = p.x - p.speed*dt
	elseif love.keyboard.isDown(p.right) then p.x = p.x + p.speed*dt
	end
	if p.tracemode and z.colTrace(math.floor(p.x+0.5),math.floor(p.y+0.5)) then p.x,p.y = old_x,old_y end
	if not z.collision(math.floor(p.x+0.5),math.floor(p.y+0.5)) then p.x,p.y = old_x,old_y end
	p.tracemode = not z.onBorder(p.x,p.y)
end

function PlayerClass.draw()
	-- player
	if p.tracemode then love.graphics.setColor(255, 0, 0) else love.graphics.setColor(255, 255, 255) end
	love.graphics.circle("line",p.x,p.y,2,12)
end
